# -----------------------------------------------------------------------------
sub infLongTX($thishost)
{
  ($thishost) = @_;

  if ($t_longtx[$thishost] eq "")
  {
    logit("Not selected for this instance",$thishost);
    return 1;
  }

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (substr($sw_version[$thishost],0,1) lt "7")
  {
    &logit("LongTX checking only works on Informix version >= 7",$thishost);
    return 0;
  }

  if (substr($os_version[$thishost],0,1) eq "0")
  {
    &logit("LongTX checking only works on HP-UX version >= 10",$thishost);
    return 0;
  }

  #
  # Run downloaded routine
  #

  &remsh("onstat -;export PATH=\$PATH:$infdir[$thishost]/bin;$probe[$thishost] longtx -sql",$tmpfl2,$thishost);

  $hwmpct = 0;

  open(TMPFL2, "$tmpfl2"  ) || &error_msg("Can't open input $tmpfl2 - $!");
  while(<TMPFL2>)
  {
    &parse;

    if ($F1 eq "--")
    {
      $hwmpct = $F11;
    }

    if ($hwmpct > $t_longtx[$thishost])
    {
      &event("U",$thishost,"Possible Long TX Detected - HWMPCT: $hwmpct (threshold=$t_longtx[$thishost])","LongTX","DBA410U",$tmpfl2);
      return;
    }
  }
  close(TMPFL2);
  &logit("OK",$thishost);
}
# -----------------------------------------------------------------------------
1;
