# -----------------------------------------------------------------------------
sub sapUp
{
  ($thishost) = @_;

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  # Start with a clean slate
  $up[$thishost] = "";

  $cmd = "$probe[$thishost] $sapsid[$thishost] up";
  ##print "cmd=$cmd \n";

  $must_connect = 1;

  ##print "up before=$up[$thishost]\n"; 
  &remsh($cmd,$tmpfl3,$thishost);
  ##print "up after=$up[$thishost]\n"; 

  ##system("cat $tmpfl3");

  if ($up[$thishost] eq "N")     # Remsh error
  {
    &logit("(Connect Error)",$thishost);
    return;
  }

  if ($t_mustbeup[$thishost] eq "Y") { $downsev = "C"; }
  else                               { $downsev = "I"; }

  $ngflag = "";

  $applhost = "";
  $errorprocesses = "";
  $pf = "";
  $db = "";

  $rmt_hostname[$thishost] = "";

  $numstart = -1;
  $numstart = -1;
  $numdw = -1;
  $numms = -1;
  $numco = -1;
  $numse = -1;
  $wp_no_dia = -1;
  $wp_no_btc = -1;
  $wp_no_enq = -1;
  $wp_no_spo = -1;
  $wp_no_vb  = -1;
  $wp_no_vb2 = -1;
  $wp_total  = -1;
  $wp_shouldbe = -1;

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    if ($F1 eq "Hostname:")      { $applhost = $F2; }

    if ($F1 eq "Physical_RAM_MB:")  { $hw_memory[$thishost] = $F2 }
    if ($F1 eq "Num_Processors:")   { $hw_processors[$thishost] = $F2 }
    if ($F1 eq "SAPVERSION:")       { $sw_version[$thishost] = $F2 }
    if ($F1 eq "SAPNUMSTART:")   { $numstart = $F2 }
    if ($F1 eq "SAPNUMDW:")      { $numdw = $F2 }
    if ($F1 eq "SAPNUMMS:")      { $numms = $F2 }
    if ($F1 eq "SAPNUMCO:")      { $numco = $F2 }
    if ($F1 eq "SAPNUMSE:")      { $numse = $F2 }
    if ($F1 eq "PF:")            { $pf = $F2 }
    if ($F1 eq "DBMS:")          { $db = $F2 }
    if ($F1 eq "wp_no_dia:")     { $wp_no_dia = $F2 }
    if ($F1 eq "wp_no_btc:")     { $wp_no_btc = $F2 }
    if ($F1 eq "wp_no_enq:")     { $wp_no_enq = $F2 }
    if ($F1 eq "wp_no_spo:")     { $wp_no_spo = $F2 }
    if ($F1 eq "wp_no_vb:")      { $wp_no_vb  = $F2 }
    if ($F1 eq "wp_no_vb2:")     { $wp_no_vb2 = $F2 }
    if ($F1 eq "wp_total:")      { $wp_total  = $F2 }
    if ($F1 eq "wp_shouldberunning:")      { $wp_shouldbe  = $F2 }

    if ($F1 eq "MODE" && $F2 ne "getconf")
    {
      $os_mode[$thishost] = $F2
    }

    if ($F1 eq "HOSTNAME:")       { $rmt_hostname[$thishost] = $F2 }

    if (substr($F1,0,4) eq "9000")
    {
      @words = split(/\//,$F0);
      $model = $words[2];
      $hw_model[$thishost] = $model;
    }
    if ($F1 eq "HP-UX")
    {
      $os_version[$thishost] = substr($F3,2);
    }
    if ($F5 eq "ErrorProcesses:") 
    {
      $errorprocesses = $F6 . $F7 . $F8 . $F9 . $F10 . $F11 . $F12 . $F13 . $F14 . $F15;
    }
    if ($F4 eq "PROCESSSTART")
    {
      $ngflag = 1;
      &event("$downsev",$thishost,"$applhost - SAP Down - sapstart Process Not Running - Number Found: $F5 - Should Be: $F6","SAPDownStr","DBA101",$tmpfl3);
    }
    if ($F4 eq "PROCESSERROR")
    {
      $ngflag = 1;
      &event("$downsev",$thishost,"$applhost - Missing $F3 process(es) - Number Found: $F5 - Should Be: $F6","SAPMissProc","DBA101",$tmpfl3);
    }
    if ($F2 eq "DBCHECKNG")
    {
      $ngflag = 1;
      &event("$downsev",$thishost,"$applhost - SAP (R3check) Cannot Connect to DB","DBConn","DBA102",$tmpfl3);
    }
    if ($F1 eq "BDFUSRSAPDIR:")
    {
      $bdfsize = $F2;
      $bdfused = $F3;
      $bdfaval = $F4;
      $bdfpct  = $F5;
      $bdfname = $F6;
      $bdfflag = $F7;
      if ($bdfflag ne "OK")
      {
	if ($bdfflag eq "C")
	{
	  &event("C",$thishost,"$applhost - /usr/sap/SID Filesystem is $bdfpct full ($bdfaval MB Free)","SAPDirFull","DBA165C",$tmpfl3);
	}
	else
	{
	  &event("C",$thishost,"$applhost - Error running bdf /usr/sap/SID","SAPDirErr","DBA166C",$tmpfl3);
	}
      }
    }
  }
  close(TMPFL3);

  if ($wp_total == -1)
  {
    $ngflag = 1;
    &event("$downsev",$thishost,"$applhost - SAP Down - No Work Processes Running","SAPDownWP","DBA101",$tmpfl3);
  }

  if ($sw_version[$thishost] lt $ver_sap_low  || $ver_sap_low eq "" ) { $ver_sap_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] gt $ver_sap_high || $ver_sap_high eq "") { $ver_sap_high = $sw_version[$thishost] }


  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Type:<td align=right>$f_s $os[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Version:<td align=right>$f_s $os_version[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Mode:<td align=right>$f_s $os_mode[$thishost]<td>(32, 64 or Blank)");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Type:<td align=right>$f_s $hw_model[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory (MB):<td align=right>$f_s $hw_memory[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Processor Count:<td align=right>$f_s $hw_processors[$thishost]");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>SAP Version:<td align=right>$f_s $sw_version[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>DBMS:<td align=right>$f_s $db");
  &logDetails($thishost,"<tr><td>$f_s <b>/usr/sap/SID FS Name:<td align=right>$f_s $bdfname<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>/usr/sap/SID FS Size(MB):<td align=right>$f_s $bdfsize<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>/usr/sap/SID FS Used(MB):<td align=right>$f_s $bdfused<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>/usr/sap/SID FS Available(MB):<td align=right>$f_s $bdfaval<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>/usr/sap/SID FS Percent Full:<td align=right>$f_s $bdfpct<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>/usr/sap/SID FS Status Flag:<td align=right>$f_s $bdfflag<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>SAP Profile: <td align=right>$f_s $pf<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>SAP Profile Parameter: wp_no_dia <td align=right>$f_s $wp_no_dia<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>SAP Profile Parameter: wp_no_btc <td align=right>$f_s $wp_no_btc<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>SAP Profile Parameter: wp_no_enq <td align=right>$f_s $wp_no_enq<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>SAP Profile Parameter: wp_no_spo <td align=right>$f_s $wp_no_spo<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>SAP Profile Parameter: wp_no_vb  <td align=right>$f_s $wp_no_vb<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>SAP Profile Parameter: wp_no_vb2 <td align=right>$f_s $wp_no_vb2<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>Total wp_no_* Count: <td align=right>$f_s $wp_total<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>sapstart Process Count:<td align=right>$f_s $numstart");
  &logDetails($thishost,"<tr><td>$f_s <b>Number of wp Processes That Should Be Running: <td align=right>$f_s $wp_shouldbe<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>dw Process Count:<td align=right>$f_s $numdw");
  &logDetails($thishost,"<tr><td>$f_s <b>ms Process Count:<td align=right>$f_s $numms");
  &logDetails($thishost,"<tr><td>$f_s <b>co Process Count:<td align=right>$f_s $numco");
  &logDetails($thishost,"</table><hr>");
  
  &history_dummy($thishost);

  $backup_method_long[$thishost] = "N/A";

  if (! $ngflag)
  {
    $up[$thishost] = "Y";
    &logit("OK - numdw=$numdw numms=$numms numco=$numco wp_total=$wp_total numstart=$numstart pf=$pf",$thishost);
  }

  # Read SWVer data

  foreach (@swver_data)
  {
    next if $_ !~ /^$dbmsout[$thishost]/;
    @words = split;
    $this_family = $words[1];
    $this_minver = $words[2];

    ##print "$titleraw[$thishost] $sw_version[$thishost] - Found this_family=$this_family this_minver=$this_minver\n";

    # Continue only if this is OUR family
    next if $sw_version[$thishost] !~ /^$this_family/;

    $z = length($this_minver);
    if (substr($sw_version[$thishost],0,$z) lt $this_minver)
    {
      &event("U",$thishost,"$dbmsout[$thishost] Version $sw_version[$thishost] is older than the minimum 'good' version ($this_minver) for this family ($this_family)","SWVER-OldVer","DBA652");
    }
  }
}
# -----------------------------------------------------------------------------
1;
